#pragma once
#include "deltatypes.h"

ByteCode ApiCall(ByteCode input);

// 00 - NULL (Reserved for the scripting engine!)
// 01 - Engine (Management Functions)
// 02 - Input
#define input_keytext(formatting, player) ((TXT)ApiCall(ByteCode(0x02,0x01)((NUM)(formatting))((NUM)player))))
#define input_btntext(player)             ((TXT)ApiCall(ByteCode(0x02,0x02)((NUM)(player))))
#define input_keyname(key)                ((TXT)ApiCall(ByteCode(0x02,0x03)((NUM)(key))))
#define input_btnname(button)             ((TXT)ApiCall(ByteCode(0x02,0x04)((NUM)(button))))
#define input_akey(player)                ((NUM)ApiCall(ByteCode(0x02,0x05)((NUM)(player))))
#define input_abtn(player)                ((NUM)ApiCall(ByteCode(0x02,0x06)((NUM)(player))))
#define input_ckey(ascii)                 ((NUM)ApiCall(ByteCode(0x02,0x07)((NUM)(ascii))))
#define input_keyascii(key)               ((TXT)ApiCall(ByteCode(0x02,0x08)((NUM)(key))))
#define input_btn(button, player)         ((NUM)ApiCall(ByteCode(0x02,0x09)((NUM)(button))((NUM)(player))))
#define input_qbtn(button, player)        ((NUM)ApiCall(ByteCode(0x02,0x0A)((NUM)(button))((NUM)(player))))
#define input_dqbtn(button, player)       ((NUM)ApiCall(ByteCode(0x02,0x0B)((NUM)(button))((NUM)(player))))
#define input_key(key, player)            ((NUM)ApiCall(ByteCode(0x02,0x0C)((NUM)(key))((NUM)(player))))
#define input_qkey(key, player)           ((NUM)ApiCall(ByteCode(0x02,0x0D)((NUM)(key))((NUM)(player))))
#define input_dqkey(key, player)          ((NUM)ApiCall(ByteCode(0x02,0x0E)((NUM)(key))((NUM)(player))))
#define input_keytime(key, player)        ((NUM)ApiCall(ByteCode(0x02,0x0F)((NUM)(key))((NUM)(player))))
#define input_btntime(button, player)     ((NUM)ApiCall(ByteCode(0x02,0x10)((NUM)(button))((NUM)(player))))
#define input_btnkey(button, player)      ((NUM)ApiCall(ByteCode(0x02,0x11)((NUM)(button))((NUM)(player))))
#define input_position(player)                 (ApiCall(ByteCode(0x02,0x12)((NUM)(player))).operator Vx<NUM>())
#define input_keyaxis(key)                ((NUM)ApiCall(ByteCode(0x02,0x13)((NUM)(key))))
#define input_btnaxis(button, player)     ((NUM)ApiCall(ByteCode(0x02,0x14)((NUM)(button))((NUM)(player))))    
#define input_sysname(syskey)             ((TXT)ApiCall(ByteCode(0x02,0x15)((NUM)(syskey))))
#define input_sys(syskey)                 ((NUM)ApiCall(ByteCode(0x02,0x16)((NUM)(syskey))))
#define input_qsys(syskey)                ((NUM)ApiCall(ByteCode(0x02,0x17)((NUM)(syskey))))
// 03 - Audio
#define audio_is_available()                              ((BLL)ApiCall((ByteCode(0x03,0x01))()))
#define audio_is_output_disabled()                        ((BLL)ApiCall((ByteCode(0x03,0x02))()))
#define audio_get_frequency()                             ((NUM)ApiCall((ByteCode(0x03,0x03))()))
#define audio_volume_global(v)                            ((FLO)ApiCall((ByteCode(0x03,0x04))((FLO)(v))))
#define audio_volume_music(v)                             ((FLO)ApiCall((ByteCode(0x03,0x05))((FLO)(v))))
#define audio_volume_sfx(v)                               ((FLO)ApiCall((ByteCode(0x03,0x06))((FLO)(v))))
#define audio_music_init(lucid)                         ((DGEID)ApiCall((ByteCode(0x03,0x07))((NUM)(lucid))))
#define audio_music_name(m, track)                        ((TXT)ApiCall((ByteCode(0x03,0x08))((DGEID)(m))((NUM)(track))))
#define audio_music_author(m, track)                      ((TXT)ApiCall((ByteCode(0x03,0x09))((DGEID)(m))((NUM)(track))))
#define audio_music_load(m, track)                      ((MUSIC)ApiCall((ByteCode(0x03,0x0A))((DGEID)(m))((NUM)(track))))
#define audio_music_unload(id)                            ((VOI)ApiCall((ByteCode(0x03,0x0B))((MUSIC)(id))))
#define audio_music_name_by_id(id)                        ((TXT)ApiCall((ByteCode(0x03,0x0C))((MUSIC)(id))))
#define audio_music_author_by_id(id)                      ((TXT)ApiCall((ByteCode(0x03,0x0D))((MUSIC)(id))))
#define audio_music_play(id, dynamic_flags)               ((VOI)ApiCall((ByteCode(0x03,0x0E))((MUSIC)(id))((NUM)(dynamic_flags))))
#define audio_music_stop(id, duration)                    ((VOI)ApiCall((ByteCode(0x03,0x0F))((MUSIC)(id))((NUM)(duration))))
#define audio_music_pause(id, duration)                   ((BLL)ApiCall((ByteCode(0x03,0x10))((MUSIC)(id))((NUM)(duration))))
#define audio_music_is_playing(id)                        ((BLL)ApiCall((ByteCode(0x03,0x11))((MUSIC)(id))))
#define audio_music_is_paused(id)                         ((BLL)ApiCall((ByteCode(0x03,0x12))((MUSIC)(id))))
#define audio_music_is_pausing(id)                        ((BLL)ApiCall((ByteCode(0x03,0x13))((MUSIC)(id))))
#define audio_music_is_pause(id)                          ((BLL)ApiCall((ByteCode(0x03,0x14))((MUSIC)(id))))
#define audio_music_is_stopped(id)                        ((BLL)ApiCall((ByteCode(0x03,0x15))((MUSIC)(id))))
#define audio_music_is_stopping(id)                       ((BLL)ApiCall((ByteCode(0x03,0x16))((MUSIC)(id))))
#define audio_music_is_stop(id)                           ((BLL)ApiCall((ByteCode(0x03,0x17))((MUSIC)(id))))
#define audio_music_volume(id, v, duration)               ((FLO)ApiCall((ByteCode(0x03,0x18))((MUSIC)(id))((FLO)(v))((NUM)(duration))))
#define audio_music_pan(id, p)                            ((FLO)ApiCall((ByteCode(0x03,0x19))((MUSIC)(id))((FLO)(p))))
#define audio_music_dynamics(id, dynamic_flags, duration) ((NUM)ApiCall((ByteCode(0x03,0x1A))((MUSIC)(id))((NUM)(dynamic_flags))((NUM)(duration))))
#define audio_music_multiplier(id, freq_mult)             ((FLO)ApiCall((ByteCode(0x03,0x1B))((MUSIC)(id))((FLO)(freq_mult))))
#define audio_music_playlist_load(m, order, add_framegap) ((VOI)ApiCall((ByteCode(0x03,0x1C))((DGEID)(m))((NUM)(order))((NUM)(add_framegap))))
#define audio_music_playlist_unload()                     ((VOI)ApiCall((ByteCode(0x03,0x1D))()))
#define audio_music_playlist_play(track)                  ((VOI)ApiCall((ByteCode(0x03,0x1E))((NUM)(track))))
#define audio_music_playlist_pause(duration)              ((BLL)ApiCall((ByteCode(0x03,0x1F))((NUM)(duration))))
#define audio_music_playlist_stop(duration)               ((VOI)ApiCall((ByteCode(0x03,0x20))((NUM)(duration))))
#define audio_sfx_init(lucid)                           ((DGEID)ApiCall((ByteCode(0x03,0x21))((NUM)(lucid))))
#define audio_sfx_name(s, sfx)                            ((TXT)ApiCall((ByteCode(0x03,0x22))((DGEID)(s))((NUM)(sfx))))
#define audio_sfx_author(s, sfx)                          ((TXT)ApiCall((ByteCode(0x03,0x23))((DGEID)(s))((NUM)(sfx))))
#define audio_sfx_play(s, sfx, dyn_index, v, p, channel)  ((NUM)ApiCall((ByteCode(0x03,0x24))((DGEID)(s))((NUM)(sfx))((NUM)(dyn_index))((FLO)(v))((FLO)(p))((NUM)(channel))))
#define audio_sfx_stop_all()                              ((VOI)ApiCall((ByteCode(0x03,0x25))()))
#define audio_sfx_stop_inst(s, sfx)                       ((VOI)ApiCall((ByteCode(0x03,0x26))((DGEID)(s))((NUM)(sfx))))
#define audio_sfx_stop(id)                                ((VOI)ApiCall((ByteCode(0x03,0x27))((SOUND)(id))))
#define audio_sfx_pause(id)                               ((BLL)ApiCall((ByteCode(0x03,0x28))((SOUND)(id))))
#define audio_sfx_is_playing(id)                          ((BLL)ApiCall((ByteCode(0x03,0x29))((SOUND)(id))))
#define audio_sfx_is_paused(id)                           ((BLL)ApiCall((ByteCode(0x03,0x2A))((SOUND)(id))))
#define audio_sfx_volume(id, v)                           ((FLO)ApiCall((ByteCode(0x03,0x2B))((SOUND)(id))((FLO)(v))))
#define audio_sfx_pan(id, p)                              ((FLO)ApiCall((ByteCode(0x03,0x2C))((SOUND)(id))((FLO)(p))))
#define audio_sfx_multiplier(id, freq_mult)               ((FLO)ApiCall((ByteCode(0x03,0x2D))((SOUND)(id))((FLO)(freq_mult))))
// 04 - Video
#define video_is_fullscreen()              ((NUM)ApiCall((ByteCode(0x04,0x01))()))
#define video_set_mode(use_fullscreen)     ((NUM)ApiCall((ByteCode(0x04,0x02))((NUM)(use_fullscreen))))
#define video_get_resolution()             (ApiCall((ByteCode(0x04,0x03))()).operator Vx<NUM>())
#define video_get_game_resolution()        (ApiCall((ByteCode(0x04,0x04))()).operator Vx<NUM>())
#define video_set_game_resolution(w, h)    ((NUM)ApiCall((ByteCode(0x04,0x05))((NUM)(w))((NUM)(h))))
#define video_get_effective_skip_level()   ((NUM)ApiCall((ByteCode(0x04,0x06))()))
#define video_get_refresh_rate()           ((NUM)ApiCall((ByteCode(0x04,0x07))()))
#define video_get_effective_refresh_rate() ((NUM)ApiCall((ByteCode(0x04,0x08))()))
#define video_get_game_resolution_fine()   (ApiCall((ByteCode(0x04,0x09))()).operator Vx<POS>())
// 05 - Stats
#define stats_get_usage_percent(which)     ((FLO)ApiCall((ByteCode(0x05,0x01))((NUM)(which))))
#define stats_get_fps()                    ((NUM)ApiCall((ByteCode(0x05,0x02))()))
#define stats_get_average_fps()            ((FLO)ApiCall((ByteCode(0x05,0x03))()))
// 06 - NitroGUI
#define gui_show_message(title, message)          ((NUM)ApiCall((ByteCode(0x06,0x01))((TXT)(title))((TXT)(message))))
#define gui_show_message_ex(title, message, buttons, which_icon) ((NUM)ApiCall((ByteCode(0x06,0x02))((TXT)(title))((TXT)(message))((NUM)(buttons))((NUM)(which_icon))))
#define gui_show_open_dialog(title, file_extensions) ((TXT)ApiCall((ByteCode(0x06,0x03))((TXT)(title))((TXT)(file_extensions))))
#define gui_show_save_dialog(title, file_extensions) ((TXT)ApiCall((ByteCode(0x06,0x04))((TXT)(title))((TXT)(file_extensions))))
#define gui_show_folder_picker(title)      ((TXT)ApiCall((ByteCode(0x06,0x05))((TXT)(title))))
#define gui_show_color_picker(title)       ((NUM)ApiCall((ByteCode(0x06,0x06))((TXT)(title))))
// 07 - Game Select [RESERVED SECTION]
// 08 - Game Control
#define game_start(dgeid)                     ((VOI)ApiCall((ByteCode(0x08,0x01))((DGEID)(dgeid))))
#define game_stop()                           ((VOI)ApiCall((ByteCode(0x08,0x02))()))
#define game_select_save_slot(slot)           ((VOI)ApiCall((ByteCode(0x08,0x03))((NUM)(slot))))
#define game_create_saves_file()              ((VOI)ApiCall((ByteCode(0x08,0x04))()))
#define game_load_saves_file()                ((NUM)ApiCall((ByteCode(0x08,0x05))()))
#define game_save()                           ((VOI)ApiCall((ByteCode(0x08,0x06))()))
#define game_load()                           ((VOI)ApiCall((ByteCode(0x08,0x07))()))
#define game_save_to_slot(slot)               ((VOI)ApiCall((ByteCode(0x08,0x08))((NUM)(slot))))
#define game_load_from_slot(slot)             ((VOI)ApiCall((ByteCode(0x08,0x09))((NUM)(slot))))
#define game_goto_screen(dgeid)               ((VOI)ApiCall((ByteCode(0x08,0x0A))((DGEID)(dgeid))))
#define game_goto_world_map(dgeid)            ((VOI)ApiCall((ByteCode(0x08,0x0B))((DGEID)(dgeid))))
#define game_goto_level(dgeid)                ((VOI)ApiCall((ByteCode(0x08,0x0C))((DGEID)(dgeid))))
#define game_set_loading_screen(dgeid)        ((VOI)ApiCall((ByteCode(0x08,0x0D))((DGEID)(dgeid))))
#define game_preload_level(dgeid)             ((VOI)ApiCall((ByteCode(0x08,0x0E))((DGEID)(dgeid))))
#define game_raise_event(event_name)          ((VOI)ApiCall((ByteCode(0x08,0x0F))((TXT)(event_name))))
#define game_respond_to_event(event_name)     ((NUM)ApiCall((ByteCode(0x08,0x10))((TXT)(event_name))))
#define game_set_global_flags(flags)          ((VOI)ApiCall((ByteCode(0x08,0x11))((NUM)(flags))))
#define game_get_global_flags()               ((NUM)ApiCall((ByteCode(0x08,0x12))()))
#define game_set_global_variable_int(name, value) ((VOI)ApiCall((ByteCode(0x08,0x13))((TXT)(name))((NUM)(value))))
#define game_get_global_variable_int(name)        ((NUM)ApiCall((ByteCode(0x08,0x14))((TXT)(name))))
#define game_set_global_variable_flo(name, value) ((VOI)ApiCall((ByteCode(0x08,0x15))((TXT)(name))((FLO)(value))))
#define game_get_global_variable_flo(name)        ((FLO)ApiCall((ByteCode(0x08,0x16))((TXT)(name))))
#define game_set_global_variable_txt(name, value) ((VOI)ApiCall((ByteCode(0x08,0x17))((TXT)(name))((TXT)(value))))
#define game_get_global_variable_txt(name)        ((TXT)ApiCall((ByteCode(0x08,0x18))((TXT)(name))))
#define game_set_flags(flags)                 ((VOI)ApiCall((ByteCode(0x08,0x19))((NUM)(flags))))
#define game_get_flags()                      ((NUM)ApiCall((ByteCode(0x08,0x1A))()))
#define game_set_variable_int(name, value)    ((VOI)ApiCall((ByteCode(0x08,0x1B))((TXT)(name))((NUM)(value))))
#define game_get_variable_int(name)           ((NUM)ApiCall((ByteCode(0x08,0x1C))((TXT)(name))))
#define game_set_variable_flo(name, value)    ((VOI)ApiCall((ByteCode(0x08,0x1D))((TXT)(name))((FLO)(value))))
#define game_get_variable_flo(name)           ((FLO)ApiCall((ByteCode(0x08,0x1E))((TXT)(name))))
#define game_set_variable_txt(name, value)    ((VOI)ApiCall((ByteCode(0x08,0x1F))((TXT)(name))((TXT)(value))))
#define game_get_variable_txt(name)           ((TXT)ApiCall((ByteCode(0x08,0x20))((TXT)(name))))
#define game_raise_global_event(event_name)          ((VOI)ApiCall((ByteCode(0x08,0x21))((TXT)(event_name))))
#define game_respond_to_global_event(event_name)     ((NUM)ApiCall((ByteCode(0x08,0x22))((TXT)(event_name))))
#define game_unraise_event(event_name)          ((VOI)ApiCall((ByteCode(0x08,0x23))((TXT)(event_name))))
#define game_unraise_global_event(event_name)   ((VOI)ApiCall((ByteCode(0x08,0x24))((TXT)(event_name))))
// 09 - Level Control
#define level_start()                         ((VOI)ApiCall((ByteCode(0x09,0x01))()))
#define level_stop()                          ((VOI)ApiCall((ByteCode(0x09,0x02))()))
#define level_reset()                         ((VOI)ApiCall((ByteCode(0x09,0x03))()))
#define level_fade(duration)                  ((VOI)ApiCall((ByteCode(0x09,0x04))((NUM)(duration))))
#define level_enter(type, where)              ((VOI)ApiCall((ByteCode(0x09,0x05))((NUM)(type))((NUM)(where))))
#define level_exit(type)                      ((VOI)ApiCall((ByteCode(0x09,0x06))((NUM)(type))))
#define level_raise_event(event_name)         ((VOI)ApiCall((ByteCode(0x09,0x07))((TXT)(event_name))))
#define level_respond_to_event(event_name)    ((NUM)ApiCall((ByteCode(0x09,0x08))((TXT)(event_name))))
#define level_set_flags(flags)                ((VOI)ApiCall((ByteCode(0x09,0x09))((NUM)(flags))))
#define level_get_flags()                     ((NUM)ApiCall((ByteCode(0x09,0x0A))()))
#define level_set_variable_int(name, value)   ((VOI)ApiCall((ByteCode(0x09,0x0B))((TXT)(name))((NUM)(value))))
#define level_get_variable_int(name)          ((NUM)ApiCall((ByteCode(0x09,0x0C))((TXT)(name))))
#define level_set_variable_flo(name, value)   ((VOI)ApiCall((ByteCode(0x09,0x0D))((TXT)(name))((FLO)(value))))
#define level_get_variable_flo(name)          ((FLO)ApiCall((ByteCode(0x09,0x0E))((TXT)(name))))
#define level_set_variable_txt(name, value)   ((VOI)ApiCall((ByteCode(0x09,0x0F))((TXT)(name))((TXT)(value))))
#define level_get_variable_txt(name)          ((TXT)ApiCall((ByteCode(0x09,0x10))((TXT)(name))))
#define level_pause()                         ((VOI)ApiCall((ByteCode(0x09,0x11))()))
// 0A - Object Control
#define object_get_id()                          ((OBJID)ApiCall((ByteCode(0x0A,0x01))()))
#define object_get_engine_id(obj)                  ((NUM)ApiCall((ByteCode(0x0A,0x02))((OBJID)(obj))))
#define object_get_name(obj)                       ((TXT)ApiCall((ByteCode(0x0A,0x03))((OBJID)(obj))))
#define object_find(obj,px,py,flags)             ((OBJID)ApiCall((ByteCode(0x0A,0x04))((OBJID)(obj))((POS)(px))((POS)(py))((NUM)(flags))))
#define object_set_int(obj, code, value)           ((VOI)ApiCall((ByteCode(0x0A,0x0A))((OBJID)(obj))((NUM)(code))((NUM)(value))))
#define object_get_int(obj, code)                  ((NUM)ApiCall((ByteCode(0x0A,0x0B))((OBJID)(obj))((NUM)(code))))
#define object_set_flo(obj, code, value)           ((VOI)ApiCall((ByteCode(0x0A,0x0C))((OBJID)(obj))((NUM)(code))((FLO)(value))))
#define object_get_flo(obj, code)                  ((FLO)ApiCall((ByteCode(0x0A,0x0D))((OBJID)(obj))((NUM)(code))))
#define object_set_flags(obj, flags)               ((VOI)ApiCall((ByteCode(0x0A,0x0E))((OBJID)(obj))((NUM)(flags))))
#define object_get_flags(obj)                      ((NUM)ApiCall((ByteCode(0x0A,0x0F))((OBJID)(obj))))
#define object_set_variable_int(obj, name, value)  ((VOI)ApiCall((ByteCode(0x0A,0x10))((OBJID)(obj))((NUM)(name))((NUM)(value))))
#define object_get_variable_int(obj, name)         ((NUM)ApiCall((ByteCode(0x0A,0x11))((OBJID)(obj))((NUM)(name))))
#define object_set_variable_flo(obj, name, value)  ((VOI)ApiCall((ByteCode(0x0A,0x12))((OBJID)(obj))((NUM)(name))((FLO)(value))))
#define object_get_variable_flo(obj, name)         ((FLO)ApiCall((ByteCode(0x0A,0x13))((OBJID)(obj))((NUM)(name))))
#define object_get_distance_to(obj)                ((FLO)ApiCall((ByteCode(0x0A,0x16))((OBJID)(obj))))
#define object_get_nearest_tile_coords(obj, layer) (ApiCall((ByteCode(0x0A,0x17))((OBJID)(obj))((NUM)(layer))).operator Vx<NUM>())
#define object_set_sprite(obj, dpx)                ((VOI)ApiCall((ByteCode(0x0A,0x18))((OBJID)(obj))((DGEID)(dpx))))
#define object_set_animation(obj, name)            ((VOI)ApiCall((ByteCode(0x0A,0x19))((OBJID)(obj))((TXT)(name))))
#define object_set_animation_speed(obj, speed)     ((VOI)ApiCall((ByteCode(0x0A,0x1A))((OBJID)(obj))((FLO)(speed))))
#define object_set_frame_number(obj, frame)        ((VOI)ApiCall((ByteCode(0x0A,0x1B))((OBJID)(obj))((FLO)(frame))))
#define object_physics_set_handler(obj, dlo)       ((VOI)ApiCall((ByteCode(0x0A,0x1C))((OBJID)(obj))((DGEID)(dlo))))
#define object_physics_enable(obj)                 ((VOI)ApiCall((ByteCode(0x0A,0x1D))((OBJID)(obj))))
#define object_physics_disable(obj)                ((VOI)ApiCall((ByteCode(0x0A,0x1E))((OBJID)(obj))))
#define object_raise_event(obj, event_name)        ((VOI)ApiCall((ByteCode(0x0A,0x1F))((OBJID)(obj))((NUM)(event_name))))
#define object_raise_event_radius(obj, event_name, radius) ((VOI)ApiCall((ByteCode(0x0A,0x20))((OBJID)(obj))((NUM)(event_name))((FLO)(radius))))
#define object_respond_to_event(obj, event_name)   ((NUM)ApiCall((ByteCode(0x0A,0x21))((OBJID)(obj))((NUM)(event_name))))
#define object_inherit(obj, inherit)               ((VOI)ApiCall((ByteCode(0x0A,0x22))((OBJID)(obj))((DGEID)(inherit))))
#define object_uninherit(obj, uninherit)           ((VOI)ApiCall((ByteCode(0x0A,0x23))((OBJID)(obj))((DGEID)(uninherit))))
#define object_set_payload(obj, payload)           ((VOI)ApiCall((ByteCode(0x0A,0x24))((OBJID)(obj))((NUM)(payload))))
#define object_remove_payload(obj)                 ((VOI)ApiCall((ByteCode(0x0A,0x25))((OBJID)(obj))))
#define object_collisions_enable(obj)              ((VOI)ApiCall((ByteCode(0x0A,0x28))((OBJID)(obj))))
#define object_collisions_disable(obj)             ((VOI)ApiCall((ByteCode(0x0A,0x29))((OBJID)(obj))))
#define object_collisions_select_block_box(obj, boxid) ((VOI)ApiCall((ByteCode(0x0A,0x2A))((OBJID)(obj))((NUM)(boxid))))
#define object_platform_enable(obj)                ((VOI)ApiCall((ByteCode(0x0A,0x2B))((OBJID)(obj))))
#define object_platform_disable(obj)               ((VOI)ApiCall((ByteCode(0x0A,0x2C))((OBJID)(obj))))
#define object_enable(obj,always)                  ((VOI)ApiCall((ByteCode(0x0A,0x2D))((OBJID)(obj))((NUM)(always))))
#define object_disable(obj,always)                 ((VOI)ApiCall((ByteCode(0x0A,0x2E))((OBJID)(obj))((NUM)(always))))
#define object_hide(obj)                           ((VOI)ApiCall((ByteCode(0x0A,0x2F))((OBJID)(obj))))
#define object_show(obj)                           ((VOI)ApiCall((ByteCode(0x0A,0x30))((OBJID)(obj))))
#define object_delete(obj)                         ((VOI)ApiCall((ByteCode(0x0A,0x31))((OBJID)(obj))))
#define object_is_deleted(obj)                     ((NUM)ApiCall((ByteCode(0x0A,0x32))((OBJID)(obj))))
#define object_set_position(obj, x, y)             ((VOI)ApiCall((ByteCode(0x0A,0x33))((OBJID)(obj))((POS)(x))((POS)(y))))
#define object_get_position(obj)                   (ApiCall((ByteCode(0x0A,0x34))((OBJID)(obj))).operator Vx<POS>())
#define object_get_startup_position(obj)           (ApiCall((ByteCode(0x0A,0x35))((OBJID)(obj))).operator Vx<POS>())
#define object_find_all_in_area(obj,l,t,r,b,dgeid,name,flags)      (ApiCall((ByteCode(0x0A,0x36))((OBJID)(obj))((POS)(l))((POS)(t))((POS)(r))((POS)(b))((NUM)(dgeid))((TXT)(name))((NUM)(flags))).operator Vx<OBJID>())
#define object_find_all_in_radius(obj,x,y,radius,dgeid,name,flags) (ApiCall((ByteCode(0x0A,0x37))((OBJID)(obj))((POS)(x))((POS)(y))((POS)(radius))((NUM)(dgeid))((TXT)(name))((NUM)(flags))).operator Vx<OBJID>())
#define object_create_payload(obj)               ((OBJID)ApiCall((ByteCode(0x0A,0x39))((OBJID)(obj))))
#define object_switch_to_screen_coords(obj)        ((VOI)ApiCall((ByteCode(0x0A,0x3A))((OBJID)(obj))))
#define object_switch_to_level_coords(obj)         ((VOI)ApiCall((ByteCode(0x0A,0x3B))((OBJID)(obj))))
#define object_set_animation_by_id(obj, which)     ((VOI)ApiCall((ByteCode(0x0A,0x3D))((OBJID)(obj))((NUM)(which))))
#define object_collisions_get_coords(obj, boxid, code)   ((VOI)ApiCall((ByteCode(0x0A,0x44))((OBJID)(obj))((NUM)(boxid))((NUM)(code))))
// 0B - DELTA Base Physics Functions
#define physics_move_to_point(x, y)                (ApiCall((ByteCode(0x0B,0x01))((POS)(x))((POS)(y))).operator Vx<POS>())
#define physics_blocks_enable(layer)               ((VOI)ApiCall((ByteCode(0x0B,0x02))((NUM)(layer))))
#define physics_blocks_disable(layer)              ((VOI)ApiCall((ByteCode(0x0B,0x03))((NUM)(layer))))
#define physics_calculate_speed(speed, target, drift, accel_div) ((FLO)ApiCall((ByteCode(0x0B,0x06))((POS)(speed))((POS)(target))((POS)(drift))((POS)(accel_div))))
#define physics_calculate_speed_dt(speed, target)       ((FLO)ApiCall((ByteCode(0x0B,0x07))((POS)(speed))((POS)(target))))
// 0C - Non-Object Layer Control
#define layer_get_id(name)                         ((LAYER)ApiCall((ByteCode(0x0C,0x01))((TXT)(name))))
#define layer_get_tile_size(layer)                   (ApiCall((ByteCode(0x0C,0x03))((LAYER)(layer))).operator Vx<NUM>())
#define layer_animation_set_speed(layer, speed)      ((VOI)ApiCall((ByteCode(0x0C,0x04))((LAYER)(layer))((FLO)(speed))))
#define layer_animation_start(layer)                 ((VOI)ApiCall((ByteCode(0x0C,0x05))((LAYER)(layer))))
#define layer_animation_stop(layer)                  ((VOI)ApiCall((ByteCode(0x0C,0x06))((LAYER)(layer))))
#define layer_set_slot_tile(layer, tx, ty, tile_num) ((VOI)ApiCall((ByteCode(0x0C,0x07))((LAYER)(layer))((NUM)(tx))((NUM)(ty))((NUM)(tile_num))))
#define layer_get_slot_tile(layer, tx, ty)           ((NUM)ApiCall((ByteCode(0x0C,0x08))((LAYER)(layer))((NUM)(tx))((NUM)(ty))))
#define layer_set_slot_flags(layer, tx, ty, flags)   ((VOI)ApiCall((ByteCode(0x0C,0x09))((LAYER)(layer))((NUM)(tx))((NUM)(ty))((NUM)(flags))))
#define layer_get_slot_flags(layer, tx, ty)          ((NUM)ApiCall((ByteCode(0x0C,0x0A))((LAYER)(layer))((NUM)(tx))((NUM)(ty))))
#define layer_get_tile_coords(layer, x, y)           (ApiCall((ByteCode(0x0C,0x0E))((LAYER)(layer))((POS)(x))((POS)(y))).operator Vx<NUM>())
// 0D - Tileset Management
// 0E - Path Movements and Related Control Functions
#define path_is_active(obj)                         ((NUM)ApiCall((ByteCode(0x0E,0x01))((OBJID)(obj))))
#define path_movement_begin(obj, path)              ((VOI)ApiCall((ByteCode(0x0E,0x02))((OBJID)(obj))((PTHID)(path))))
#define path_movement_end(obj)                      ((VOI)ApiCall((ByteCode(0x0E,0x03))((OBJID)(obj))))
#define path_movement_reset(obj)                    ((VOI)ApiCall((ByteCode(0x0E,0x04))((OBJID)(obj))))
#define path_movement_set_speed(obj, speed)         ((VOI)ApiCall((ByteCode(0x0E,0x05))((OBJID)(obj))((FLO)(speed))))
#define path_movement_get_speed(obj)                ((FLO)ApiCall((ByteCode(0x0E,0x06))((OBJID)(obj))))
#define path_movement_get_rotation_value(obj, path) ((FLO)ApiCall((ByteCode(0x0E,0x07))((OBJID)(obj))((PTHID)(path))))
#define path_orbit(obj, to_orbit)                   ((VOI)ApiCall((ByteCode(0x0E,0x08))((OBJID)(obj))((NUM)(to_orbit))))
#define path_orbit_point(obj, x, y)                 ((VOI)ApiCall((ByteCode(0x0E,0x09))((OBJID)(obj))((NUM)(x))((NUM)(y))))
#define path_movement_passed_waypoint(obj, waypt)   ((NUM)ApiCall((ByteCode(0x0E,0x0A))((OBJID)(obj))((NUM)(waypt))))
#define path_movement_jump_to_waypoint(obj, waypt)  ((VOI)ApiCall((ByteCode(0x0E,0x0B))((OBJID)(obj))((NUM)(waypt))))
// 0F - Resources Management
#define resources_get_filetype(file_extension)    ((FTYPE)ApiCall((ByteCode(0x0F,0x01))((TXT)(file_extension))))
#define resources_get_engine_id(lucid, type)      ((DGEID)ApiCall((ByteCode(0x0F,0x02))((LUCID)(lucid))((FTYPE)(type))))
#define resources_load_engine_id(lucid, type)     ((DGEID)ApiCall((ByteCode(0x0F,0x03))((LUCID)(lucid))((FTYPE)(type))))
// 10 - Programming Constructs
#define program_simultaneous(code)              ((VOI)ApiCall((ByteCode(0x10,0x01))((DSXID)(code))))
#define program_sequential(code)                ((VOI)ApiCall((ByteCode(0x10,0x02))((DSXID)(code))))
#define program_while(condition, code)          ((VOI)ApiCall((ByteCode(0x10,0x03))((NUM)(condition))((DSXID)(code))))
#define program_do_while(code, condition)       ((VOI)ApiCall((ByteCode(0x10,0x04))((NUM)(condition))((DSXID)(code))))
#define program_if(condition, code_t)           ((VOI)ApiCall((ByteCode(0x10,0x05))((NUM)(condition))((DSXID)(code_t))))
#define program_repeat(times, code)             ((VOI)ApiCall((ByteCode(0x10,0x0B))((NUM)(times))((DSXID)(code))))
#define program_constant_value()                ((NUM)ApiCall((ByteCode(0x10,0x0D))()))
#define program_add(x, y)                       ((NUM)ApiCall((ByteCode(0x10,0x0E))((NUM)(x))((Vx<NUM>)(y))))
#define program_subtract(x, y)                  ((NUM)ApiCall((ByteCode(0x10,0x0F))((NUM)(x))((NUM)(y))))
#define program_multiply(x, y)                  ((NUM)ApiCall((ByteCode(0x10,0x10))((NUM)(x))((Vx<NUM>)(y))))
#define program_divide(x, y)                    ((NUM)ApiCall((ByteCode(0x10,0x11))((NUM)(x))((NUM)(y))))
#define program_modulus(x, y)                   ((NUM)ApiCall((ByteCode(0x10,0x12))((NUM)(x))((NUM)(y))))
#define program_are_equal(x, y)                 ((NUM)ApiCall((ByteCode(0x10,0x13))((NUM)(x))((Vx<NUM>)(y))))
#define program_compare(x, y, how)              ((NUM)ApiCall((ByteCode(0x10,0x14))((NUM)(x))((NUM)(y))((NUM)(how))))
#define program_constant_value_flo()            ((FLO)ApiCall((ByteCode(0x10,0x15))()))
#define program_add_flo(x, y)                   ((FLO)ApiCall((ByteCode(0x10,0x16))((FLO)(x))((Vx<FLO>)(y))))
#define program_subtract_flo(x, y)              ((FLO)ApiCall((ByteCode(0x10,0x17))((FLO)(x))((FLO)(y))))
#define program_multiply_flo(x, y)              ((FLO)ApiCall((ByteCode(0x10,0x18))((FLO)(x))((Vx<FLO>)(y))))
#define program_divide_flo(x, y)                ((FLO)ApiCall((ByteCode(0x10,0x19))((FLO)(x))((FLO)(y))))
#define program_modulus_flo(x, y)               ((FLO)ApiCall((ByteCode(0x10,0x1A))((FLO)(x))((FLO)(y))))
#define program_are_equal_flo(x, y)             ((NUM)ApiCall((ByteCode(0x10,0x1B))((FLO)(x))((Vx<FLO>)(y))))
#define program_compare_flo(x, y, how)          ((NUM)ApiCall((ByteCode(0x10,0x1C))((FLO)(x))((FLO)(y))((NUM)(how))))
#define program_not(x)                          ((NUM)ApiCall((ByteCode(0x10,0x1D))((NUM)(x))))
#define program_and(x, y)                       ((NUM)ApiCall((ByteCode(0x10,0x1E))((NUM)(x))((NUM)(y))))
#define program_or(x, y)                        ((NUM)ApiCall((ByteCode(0x10,0x1F))((NUM)(x))((NUM)(y))))
#define program_xor(x, y)                       ((NUM)ApiCall((ByteCode(0x10,0x20))((NUM)(x))((NUM)(y))))
#define program_bit_invert(x)                   ((NUM)ApiCall((ByteCode(0x10,0x21))((NUM)(x))))
#define program_bit_and(x, y)                   ((NUM)ApiCall((ByteCode(0x10,0x22))((NUM)(x))((NUM)(y))))
#define program_bit_or(x, y)                    ((NUM)ApiCall((ByteCode(0x10,0x23))((NUM)(x))((NUM)(y))))
#define program_bit_xor(x, y)                   ((NUM)ApiCall((ByteCode(0x10,0x24))((NUM)(x))((NUM)(y))))
#define program_bit_shift_left(x, by)           ((NUM)ApiCall((ByteCode(0x10,0x25))((NUM)(x))((NUM)(by))))
#define program_bit_shift_right(x, by)          ((NUM)ApiCall((ByteCode(0x10,0x26))((NUM)(x))((NUM)(by))))
#define program_set_variable_int(code, value)   ((VOI)ApiCall((ByteCode(0x10,0x27))((NUM)(code))((NUM)(value))))
#define program_get_variable_int(code)          ((NUM)ApiCall((ByteCode(0x10,0x28))((NUM)(code))))
#define program_set_variable_flo(code, value)   ((VOI)ApiCall((ByteCode(0x10,0x29))((NUM)(code))((NUM)(value))))
#define program_get_variable_flo(code)          ((FLO)ApiCall((ByteCode(0x10,0x2A))((NUM)(code))))
#define program_wait(frames)                    ((VOI)ApiCall((ByteCode(0x10,0x2B))((NUM)(frames))))
#define program_wait_seconds(seconds)           ((VOI)ApiCall((ByteCode(0x10,0x2C))((FLO)(seconds))))
#define program_wait_until_condition(condition) ((VOI)ApiCall((ByteCode(0x10,0x2D))((NUM)(condition))))
#define program_constant_value_lucid()        ((LUCID)ApiCall((ByteCode(0x10,0x2E))()))
#define program_constant_value_text()           ((TXT)ApiCall((ByteCode(0x10,0x2F))()))
#define program_fix_to_flo(value)               ((FLO)ApiCall((ByteCode(0x10,0x30))((NUM)(value))))
#define program_flo_to_fix(value)               ((NUM)ApiCall((ByteCode(0x10,0x31))((FLO)(value))))
#define program_for_each_object(obj, code)       ((VOI)ApiCall((ByteCode(0x10,0x32))((OBJID)(obj))((DSXID)(code))))
#define program_for_each_object_get_id()      ((OBJID)ApiCall((ByteCode(0x10,0x33))()))
#define program_int_to_text(value)              ((TXT)ApiCall((ByteCode(0x10,0x34))((NUM)(value))))
#define program_text_to_int(value)              ((NUM)ApiCall((ByteCode(0x10,0x35))((TXT)(value))))
#define program_check_flag(input,which)         ((NUM)ApiCall((ByteCode(0x10,0x38))((NUM)(input))((NUM)(which))))
#define program_abs(x)                          ((NUM)ApiCall((ByteCode(0x10,0x39))((NUM)(x))))
#define program_abs_flo(x)                      ((FLO)ApiCall((ByteCode(0x10,0x3A))((FLO)(x))))
#define program_sign(x)                         ((NUM)ApiCall((ByteCode(0x10,0x3B))((NUM)(x))))
#define program_sign_flo(x)                     ((FLO)ApiCall((ByteCode(0x10,0x3C))((FLO)(x))))
#define program_ceil(x)                         ((FLO)ApiCall((ByteCode(0x10,0x3D))((FLO)(x))))
#define program_floor(x)                        ((FLO)ApiCall((ByteCode(0x10,0x3E))((FLO)(x))))
#define program_set_flag(input,which,value)     ((NUM)ApiCall((ByteCode(0x10,0x3F))((NUM)(input))((NUM)(which))((NUM)(value))))
#define program_sqrt(x)                         ((NUM)ApiCall((ByteCode(0x10,0x40))((NUM)(x))))
#define program_sqrt_flo(x)                     ((FLO)ApiCall((ByteCode(0x10,0x41))((FLO)(x))))
#define program_pow(x,power)                    ((NUM)ApiCall((ByteCode(0x10,0x42))((NUM)(x))((NUM)(power))))
#define program_pow_flo(x,power)                ((FLO)ApiCall((ByteCode(0x10,0x43))((FLO)(x))((FLO)(power))))
#define program_set_variable_int2(code,x,y)     ((VOI)ApiCall((ByteCode(0x10,0x44))((NUM)(code))((NUM)(x))((NUM)(y))))
#define program_set_variable_flo2(code,x,y)     ((VOI)ApiCall((ByteCode(0x10,0x45))((NUM)(code))((FLO)(x))((FLO)(y))))
#define program_constant_array()                (ApiCall((ByteCode(0x10,0x46))).operator Vx<NUM>())
#define program_constant_array_flo()            (ApiCall((ByteCode(0x10,0x47))).operator Vx<FLO>())
// 11 - Text and String Functions
#define text_show_message(hook, message, font, offset_x, offset_y) ((VOI)ApiCall((ByteCode(0x11,0x04))((OBJID)(hook))((TXT)(message))((DGEID)(font))((NUM)(offset_x))((NUM)(offset_y))))
#define text_hide_messages(hook)                ((VOI)ApiCall((ByteCode(0x11,0x06))((OBJID)(hook))))
// 12 - Game Config Functions (INI Files!!)
#define config_open(file)                           ((NUM)ApiCall((ByteCode(0x12,0x01))((TXT)(file))))
#define config_save()                               ((NUM)ApiCall((ByteCode(0x12,0x02))()))
#define config_set_text(section, variable, str)     ((TXT)ApiCall((ByteCode(0x12,0x03))((TXT)(section))((TXT)(variable))((TXT)(str))))
#define config_set_hex(section, variable, value)    ((NUM)ApiCall((ByteCode(0x12,0x04))((TXT)(section))((TXT)(variable))((NUM)(value))))
#define config_set_int(section, variable, value)    ((NUM)ApiCall((ByteCode(0x12,0x05))((TXT)(section))((TXT)(variable))((NUM)(value))))
#define config_set_flo(section, variable, value)    ((FLO)ApiCall((ByteCode(0x12,0x06))((TXT)(section))((TXT)(variable))((FLO)(value))))
#define config_get_text(section, variable, def)     ((TXT)ApiCall((ByteCode(0x12,0x07))((TXT)(section))((TXT)(variable))((TXT)(def))))
#define config_get_hex(section, variable, def)      ((NUM)ApiCall((ByteCode(0x12,0x08))((TXT)(section))((TXT)(variable))((NUM)(def))))
#define config_get_int(section, variable, def)      ((NUM)ApiCall((ByteCode(0x12,0x09))((TXT)(section))((TXT)(variable))((NUM)(def))))
#define config_get_flo(section, variable, def)      ((FLO)ApiCall((ByteCode(0x12,0x0A))((TXT)(section))((TXT)(variable))((FLO)(def))))
#define config_delete(section)                      ((VOI)ApiCall((ByteCode(0x12,0x0B))((TXT)(section))))
#define config_getset_int(section, variable, value) ((NUM)ApiCall((ByteCode(0x12,0x0C))((TXT)(section))((TXT)(variable))((NUM)(value))))
// 13 - Mathematics Magic
#define math_blend_positions(target, node0, node1, rotate)   (ApiCall((ByteCode(0x13,0x01))((OBJID)(target))((OBJID)(node0))((OBJID)(node1))((NUM)(rotate))).operator Vx<POS>())
#define math_compute_centroid(node0)                         (ApiCall((ByteCode(0x13,0x02))((Vx<OBJID>)(node0))).operator Vx<POS>())
#define math_random_integer(beg, end)                        ((NUM)ApiCall((ByteCode(0x13,0x03))((NUM)(beg))((NUM)(end))))
#define math_random_float(beg, end)                          ((FLO)ApiCall((ByteCode(0x13,0x04))((NUM)(beg))((NUM)(end))))
#define math_random_position(x_beg, y_beg, x_end, y_end)     (ApiCall((ByteCode(0x13,0x05))((POS)(x_beg))((POS)(y_beg))((POS)(x_end))((POS)(y_end))).operator Vx<POS>())
#define math_compute_angle_between(start, target)            ((FLO)ApiCall((ByteCode(0x13,0x06))((OBJID)(start))((OBJID)(target))))
#define math_compute_distance_between(start, target)         ((NUM)ApiCall((ByteCode(0x13,0x07))((OBJID)(start))((OBJID)(target))))
#define math_compute_distance_each_axis(start, target)       (ApiCall((ByteCode(0x13,0x08))((OBJID)(start))((OBJID)(target))).operator Vx<POS>())
#define math_keep_angle_towards_x_axis(start, target, angle) (ApiCall((ByteCode(0x13,0x09))((OBJID)(start))((OBJID)(target))((FLO)(angle))).operator Vx<POS>())
#define math_keep_angle_towards_y_axis(start, target, angle) (ApiCall((ByteCode(0x13,0x0A))((OBJID)(start))((OBJID)(target))((FLO)(angle))).operator Vx<POS>())
#define math_keep_angle_between_points(start, target, angle, one_x, one_y, two_x, two_y) (ApiCall((ByteCode(0x13,0x0B))((OBJID)(start))((OBJID)(target))((FLO)(angle))((POS)(one_x))((POS)(one_y))((POS)(two_x))((POS)(two_y))).operator Vx<POS>())
#define math_smoothing_algorithm(start_x, start_y, target_x, target_y, amount) (ApiCall((ByteCode(0x13,0x0C))((POS)(start_x))((POS)(start_y))((POS)(target_x))((POS)(target_y))((POS)(amount))).operator Vx<POS>())
// 14 - Date and Time
#define datetime_get_date_text()          ((TXT)ApiCall((ByteCode(0x14,0x01))()))
#define datetime_get_time_text()          ((TXT)ApiCall((ByteCode(0x14,0x02))()))
#define datetime_get_hour_military()      ((NUM)ApiCall((ByteCode(0x14,0x03))()))
#define datetime_get_hour()               ((NUM)ApiCall((ByteCode(0x14,0x04))()))
#define datetime_get_minute()             ((NUM)ApiCall((ByteCode(0x14,0x05))()))
#define datetime_get_second()             ((NUM)ApiCall((ByteCode(0x14,0x06))()))
#define datetime_get_frame()              ((NUM)ApiCall((ByteCode(0x14,0x07))()))
#define datetime_get_day_in_year()        ((NUM)ApiCall((ByteCode(0x14,0x08))()))
#define datetime_get_day_in_month()       ((NUM)ApiCall((ByteCode(0x14,0x09))()))
#define datetime_get_day_in_week()        ((NUM)ApiCall((ByteCode(0x14,0x0A))()))
#define datetime_get_day_in_week_text()   ((TXT)ApiCall((ByteCode(0x14,0x0B))()))
#define datetime_get_month_in_year()      ((NUM)ApiCall((ByteCode(0x14,0x0C))()))
#define datetime_get_month_in_year_text() ((TXT)ApiCall((ByteCode(0x14,0x0D))()))
// 15 - Game and Level Clock
#define clock_game_start()             ((VOI)ApiCall((ByteCode(0x15,0x01))()))
#define clock_game_stop()              ((VOI)ApiCall((ByteCode(0x15,0x02))()))
#define clock_game_get_hour()          ((NUM)ApiCall((ByteCode(0x15,0x03))()))
#define clock_game_get_minute()        ((NUM)ApiCall((ByteCode(0x15,0x04))()))
#define clock_game_get_second()        ((NUM)ApiCall((ByteCode(0x15,0x05))()))
#define clock_game_get_frame()         ((NUM)ApiCall((ByteCode(0x15,0x06))()))
#define clock_game_get_frames()        ((NUM)ApiCall((ByteCode(0x15,0x07))()))
#define clock_level_start()            ((VOI)ApiCall((ByteCode(0x15,0x08))()))
#define clock_level_stop()             ((VOI)ApiCall((ByteCode(0x15,0x09))()))
#define clock_level_get_hour()         ((NUM)ApiCall((ByteCode(0x15,0x0A))()))
#define clock_level_get_minute()       ((NUM)ApiCall((ByteCode(0x15,0x0B))()))
#define clock_level_get_second()       ((NUM)ApiCall((ByteCode(0x15,0x0C))()))
#define clock_level_get_frame()        ((NUM)ApiCall((ByteCode(0x15,0x0D))()))
#define clock_level_get_frames()       ((NUM)ApiCall((ByteCode(0x15,0x0E))()))
#define clock_game_set_frames(frames)  ((VOI)ApiCall((ByteCode(0x15,0x0F))((NUM)(frames))))
#define clock_level_set_frames(frames) ((VOI)ApiCall((ByteCode(0x15,0x10))((NUM)(frames))))
// 16 - Game Camera Control
#define camera_center_on_object(obj,xoffs,yoffs) ((VOI)ApiCall((ByteCode(0x16,0x01))((OBJID)(obj))((POS)(xoffs))((POS)(yoffs))))
#define camera_center_on_position(x, y)          ((VOI)ApiCall((ByteCode(0x16,0x02))((POS)(x))((POS)(y))))
#define camera_set_position(x, y)                ((VOI)ApiCall((ByteCode(0x16,0x03))((POS)(x))((POS)(y))))
#define camera_set_position_by_center(x, y)      ((VOI)ApiCall((ByteCode(0x16,0x04))((POS)(x))((POS)(y))))
#define camera_get_smoothing_level()             ((POS)ApiCall((ByteCode(0x16,0x05))()))
#define camera_set_smoothing_level(level)        ((VOI)ApiCall((ByteCode(0x16,0x06))((POS)(level))))
#define camera_get_position()                    (ApiCall((ByteCode(0x16,0x07))()).operator Vx<POS>())
#define camera_get_position_by_center()          (ApiCall((ByteCode(0x16,0x08))()).operator Vx<POS>())
#define camera_set_activation_bounds(l, t, r, b) ((VOI)ApiCall((ByteCode(0x16,0x09))((NUM)(l))((NUM)(t))((NUM)(r))((NUM)(b))))
#define camera_set_deactivation_bounds(l, t, r, b) ((VOI)ApiCall((ByteCode(0x16,0x0A))((NUM)(l))((NUM)(t))((NUM)(r))((NUM)(b))))
// 17 - Builtin "High Score" Functionality
#define highscore_set_count(how_many)            ((VOI)ApiCall((ByteCode(0x17,0x01))((NUM)(how_many))))
#define highscore_set_entry(which, score, name)  ((VOI)ApiCall((ByteCode(0x17,0x02))((NUM)(which))((NUM)(score))((TXT)(name))))
#define highscore_get_entry_score(which)         ((NUM)ApiCall((ByteCode(0x17,0x03))((NUM)(which))))
#define highscore_get_entry_name(which)          ((TXT)ApiCall((ByteCode(0x17,0x04))((NUM)(which))))
#define highscore_check_and_add(score, name)     ((VOI)ApiCall((ByteCode(0x17,0x05))((NUM)(score))((TXT)(name))))
#define highscore_reset_all()                    ((VOI)ApiCall((ByteCode(0x17,0x06))()))
// 18 - Custom ARGB Bitmap Drawing Routines
#define surface_create(w, h)                              ((NUM)ApiCall((ByteCode(0x18,0x01))((NUM)(w))((NUM)(h))))
#define surface_delete(surface)                           ((VOI)ApiCall((ByteCode(0x18,0x02))((NUM)(surface))))
#define surface_render(surface,x,y,color,mode,flags,flip) ((VOI)ApiCall((ByteCode(0x18,0x03))((NUM)(surface))((NUM)(x))((NUM)(y))((NUM)(color))((NUM)(mode))((NUM)(flags))((NUM)(flip))))
#define surface_access(surface)                           (((U32*))((U32))(((((U64)surface) >> 32) & 0x00000000FFFFFFFFLL)))

#define NGUI_MSG_OK          0
#define NGUI_MSG_OKCANCEL    1
#define NGUI_MSG_YESNOCANCEL 2
#define NGUI_MSG_YESNO       3
#define NGUI_MSG_SAVETOSSCANCEL 4

#define NGUI_MSGICON_NONE        0
#define NGUI_MSGICON_INFO        1
#define NGUI_MSGICON_QUESTION    2
#define NGUI_MSGICON_EXCLAMATION 3
#define NGUI_MSGICON_ERROR       4
#define NGUI_MSGICON_CONFIRM     5
#define NGUI_MSGICON_ERASE       6
#define NGUI_MSGICON_COPY        7

#ifndef _KEY_AND_BUTTON_CONSTANTS_
#define _KEY_AND_BUTTON_CONSTANTS_
#define xSYS_NULL			0xFF
#define xSYS_EXIT			0x00
#define xSYS_FULLSCREEN		0x01
#define xSYS_GAMEPOWER		0x02
#define xSYS_GAMERESET		0x03
#define xSYS_GAMESCREENSHOT	0x04
#define xSYS_PRINTSCREEN	0x05
#define xSYS_SAVESTATE      0x06
#define xSYS_LOADSTATE      0x07
#define xSYS_MAXIMUM        0x08

#define xPAD_NULL 			0xFF
#define xPAD_START			0x00
#define xPAD_SELECT			0x01
#define xPAD_UP				0x02
#define xPAD_DOWN			0x03
#define xPAD_LEFT			0x04
#define xPAD_RIGHT			0x05
#define xPAD_A				0x06
#define xPAD_B				0x07
#define xPAD_X				0x08
#define xPAD_Y				0x09
#define xPAD_L				0x0A
#define xPAD_R				0x0B
#define xPAD_L2				0x0C
#define xPAD_R2				0x0D
#define xPAD_C_UP			0x0E
#define xPAD_C_DOWN			0x0F
#define xPAD_C_LEFT			0x10
#define xPAD_C_RIGHT		0x11
#define xPAD_C				0x12
#define xPAD_Z				0x13
#define xPAD_ZL				0x14
#define xPAD_ZR				0x15
#define xPAD_1				0x16
#define xPAD_2				0x17
#define xPAD_PLUS			0x18
#define xPAD_MINUS			0x19
#define xPAD_HOME			0x1A
#define xPAD_CROSS			0x1B
#define xPAD_CIRCLE			0x1C
#define xPAD_TRIANGLE		0x1D
#define xPAD_SQUARE			0x1E
#define xPAD_POWER			0x1F

#define xKEY_NULL			0xFF
#define xKEY_ANY			0x00
#define xMOUSE_BTN_LEFT		0x01
#define xMOUSE_BTN_RIGHT	0x02
#define xMOUSE_BTN_MIDDLE	0x03
#define xMOUSE_BTN_4	    0x04
#define xMOUSE_BTN_5	    0x05
#define xMOUSE_SCROLL_MINUS	0x06
#define xMOUSE_SCROLL_PLUS	0x07
#define xKEY_ENTER			0x08
#define xKEY_LEFT			0x09
#define xKEY_RIGHT			0x0A
#define xKEY_UP				0x0B
#define xKEY_DOWN			0x0C
#define xKEY_TAB			0x0D
#define xKEY_ESC			0x0E
#define xKEY_MENU			0x0F
#define xKEY_COMMAND		0x0F
#define xKEY_F1				0x10
#define xKEY_F2				0x11
#define xKEY_F3				0x12
#define xKEY_F4				0x13
#define xKEY_F5				0x14
#define xKEY_F6				0x15
#define xKEY_F7				0x16
#define xKEY_F8				0x17
#define xKEY_F9				0x18
#define xKEY_F10			0x19
#define xKEY_F11			0x1A
#define xKEY_F12			0x1B
#define xKEY_F13			0x1C
#define xKEY_F14			0x1D
#define xKEY_F15			0x1E
#define xKEY_F16			0x1F
#define xKEY_F17			0x20
#define xKEY_F18			0x21
#define xKEY_F19			0x22
#define xKEY_F20			0x23
#define xKEY_F21			0x24
#define xKEY_F22			0x25
#define xKEY_F23			0x26
#define xKEY_F24			0x27
#define xKEY_PAUSE			0x28
#define xKEY_SCRLOCK		0x29
#define xKEY_NUMLOCK		0x2A
#define xKEY_CAPSLOCK		0x2B
#define xKEY_WIN			0x2C // ABSTRACTION USING xKEY_LWIN/xKEY_RWIN EVENTS.
#define xKEY_WINDOWS		0x2C // ABSTRACTION USING xKEY_LWIN/xKEY_RWIN EVENTS.
#define xKEY_SHIFT			0x2D // RE-PIPED TO LEFT/RIGHT VERSIONS, THEN ABSTRACTED BACK TO HERE.
#define xKEY_CONTROL		0x2E // RE-PIPED TO LEFT/RIGHT VERSIONS, THEN ABSTRACTED BACK TO HERE.
#define xKEY_CTRL			0x2E // RE-PIPED TO LEFT/RIGHT VERSIONS, THEN ABSTRACTED BACK TO HERE.
#define xKEY_ALT			0x2F // RE-PIPED TO LEFT/RIGHT VERSIONS, THEN ABSTRACTED BACK TO HERE.
#define xKEY_LWIN			0x30
#define xKEY_RWIN			0x31
#define xKEY_LWINKEY		0x30
#define xKEY_RWINKEY		0x31
#define xKEY_LWINDOWS		0x30
#define xKEY_RWINDOWS		0x31
#define xKEY_LSHIFT			0x32
#define xKEY_RSHIFT			0x33
#define xKEY_LCONTROL		0x34
#define xKEY_RCONTROL		0x35
#define xKEY_LCTRL			0x34
#define xKEY_RCTRL			0x35
#define xKEY_LALT			0x36
#define xKEY_RALT			0x37
#define xKEY_PRTSCR			0x38
#define xKEY_PRINTSCREEN	0x38
#define xKEY_BACKSPACE		0x39
#define xKEY_INSERT			0x3A
#define xKEY_DELETE			0x3B
#define xKEY_DEL			0x3B
#define xKEY_HOME			0x3C
#define xKEY_END			0x3D
#define xKEY_PGUP			0x3E
#define xKEY_PGDN			0x3F
#define xKEY_0				0x40
#define xKEY_1				0x41
#define xKEY_2				0x42
#define xKEY_3				0x43
#define xKEY_4				0x44
#define xKEY_5				0x45
#define xKEY_6				0x46
#define xKEY_7				0x47
#define xKEY_8				0x48
#define xKEY_9				0x49
#define xKEY_A				0x4A
#define xKEY_B				0x4B
#define xKEY_C				0x4C
#define xKEY_D				0x4D
#define xKEY_E				0x4E
#define xKEY_F				0x4F
#define xKEY_G				0x50
#define xKEY_H				0x51
#define xKEY_I				0x52
#define xKEY_J				0x53
#define xKEY_K				0x54
#define xKEY_L				0x55
#define xKEY_M				0x56
#define xKEY_N				0x57
#define xKEY_O				0x58
#define xKEY_P				0x59
#define xKEY_Q				0x5A
#define xKEY_R				0x5B
#define xKEY_S				0x5C
#define xKEY_T				0x5D
#define xKEY_U				0x5E
#define xKEY_V				0x5F
#define xKEY_W				0x60
#define xKEY_X				0x61
#define xKEY_Y				0x62
#define xKEY_Z				0x63
#define xKEY_SPACE			0x64
#define xKEY_GRAVE			0x65
#define xKEY_MINUS			0x66
#define xKEY_EQUALS			0x67
#define xKEY_COMMA			0x68
#define xKEY_PERIOD			0x69
#define xKEY_SLASH			0x6A
#define xKEY_SEMICOLON		0x6B
#define xKEY_QUOTE			0x6C
#define xKEY_OPENBRACE		0x6D
#define xKEY_CLOSEBRACE		0x6E
#define xKEY_BACKSLASH		0x6F
#define xKEY_NUM_0			0x70
#define xKEY_NUM_1			0x71
#define xKEY_NUM_2			0x72
#define xKEY_NUM_3			0x73
#define xKEY_NUM_4			0x74
#define xKEY_NUM_5			0x75
#define xKEY_NUM_6			0x76
#define xKEY_NUM_7			0x77
#define xKEY_NUM_8			0x78
#define xKEY_NUM_9			0x79
#define xKEY_NUM_ADD		0x7A
#define xKEY_NUM_SUBTRACT	0x7B
#define xKEY_NUM_MULTIPLY	0x7C
#define xKEY_NUM_DIVIDE		0x7D
#define xKEY_NUM_DECPOINT	0x7E
#define xKEY_NUM_ENTER		0x7F
#define xCURSOR_POS_X 	    0x80 // Follows hardware cursor via GetCursorPos().
#define xCURSOR_POS_Y		0x81 // Follows hardware cursor via GetCursorPos().
#define xMOUSE_X		    0x82 // Raw, arbitrary mouse coordinates.
#define xMOUSE_Y		    0x83 // Raw, arbitrary mouse coordinates.
#define xAXIS_X			    0x84 // axis data in 65536ths, signed value.
#define xAXIS_Y			    0x85 // axis data in 65536ths, signed value.
#define xAXIS_Z			    0x86 // axis data in 65536ths, signed value.
#define xAXIS_RX			0x87 // axis data in 65536ths, signed value.
#define xAXIS_RY			0x88 // axis data in 65536ths, signed value.
#define xAXIS_RZ			0x89 // axis data in 65536ths, signed value.
#define xAXIS_SLIDER1		0x8A // axis data in 65536ths, unsigned value.
#define xAXIS_DIAL			0x8B // axis data in 65536ths, unsigned value.
#define xAXIS_WHEEL		    0x8C // axis data in 65536ths, unsigned value.
#define xAXIS_SLIDER2		0x8D // axis data in 65536ths, unsigned value.
#define xAXIS_RUDDER		0x8E // axis data in 65536ths, signed value.
#define xAXIS_THROTTLE		0x8F // axis data in 65536ths, unsigned value.
#define xBTN_X_MINUS		0x90
#define xBTN_X_PLUS 		0x91
#define xBTN_Y_MINUS		0x92
#define xBTN_Y_PLUS		    0x93
#define xBTN_Z_MINUS		0x94
#define xBTN_Z_PLUS		    0x95
#define xBTN_RX_MINUS		0x96
#define xBTN_RX_PLUS		0x97
#define xBTN_RY_MINUS		0x98
#define xBTN_RY_PLUS		0x99
#define xBTN_RZ_MINUS		0x9A
#define xBTN_RZ_PLUS		0x9B
#define xBTN_DPAD_LEFT		0x9C
#define xBTN_DPAD_RIGHT		0x9D
#define xBTN_DPAD_UP		0x9E
#define xBTN_DPAD_DOWN		0x9F
#define xBTN_00				0xA0
#define xBTN_01				0xA1
#define xBTN_02				0xA2
#define xBTN_03				0xA3
#define xBTN_04				0xA4
#define xBTN_05				0xA5
#define xBTN_06				0xA6
#define xBTN_07				0xA7
#define xBTN_08				0xA8
#define xBTN_09				0xA9
#define xBTN_0A				0xAA
#define xBTN_0B				0xAB
#define xBTN_0C				0xAC
#define xBTN_0D				0xAD
#define xBTN_0E				0xAE
#define xBTN_0F				0xAF
#define xBTN_10				0xB0
#define xBTN_11				0xB1
#define xBTN_12				0xB2
#define xBTN_13				0xB3
#define xBTN_14				0xB4
#define xBTN_15				0xB5
#define xBTN_16				0xB6
#define xBTN_17				0xB7
#define xBTN_18				0xB8
#define xBTN_19				0xB9
#define xBTN_1A				0xBA
#define xBTN_1B				0xBB
#define xBTN_1C				0xBC
#define xBTN_1D				0xBD
#define xBTN_1E				0xBE
#define xBTN_1F				0xBF


#define xKEY_ZERO			0x40
#define xKEY_ONE			0x41
#define xKEY_TWO			0x42
#define xKEY_THREE			0x43
#define xKEY_FOUR			0x44
#define xKEY_FIVE			0x45
#define xKEY_SIX			0x46
#define xKEY_SEVEN			0x47
#define xKEY_EIGHT			0x48
#define xKEY_NINE			0x49
#define xKEY_RETURN			0x08
#define xKEY_BREAK			0x28
#define xKEY_SYSRQ      	0x38
#define xKEY_PAGEUP			0x3E
#define xKEY_PAGEDOWN	    0x3F
#define xKEY_RIGHTPARENTHESIS 0x40
#define xKEY_CLOSINGPARENTHESIS 0x40
#define xKEY_CLOSEPARENTHESIS 0x40
#define xKEY_EXCLAMATION	0x41
#define xKEY_EXCLAMATIONPOINT 0x41
#define xKEY_AT				0x42
#define xKEY_ATSYMBOL		0x42
#define xKEY_ATSIGN 		0x42
#define xKEY_NUMBERSIGN		0x43
#define xKEY_POUND			0x43
#define xKEY_HASH			0x43
#define xKEY_OCTOTHORP		0x43
#define xKEY_DOLLAR			0x44
#define xKEY_DOLLARSIGN		0x44
#define xKEY_PERCENT		0x45
#define xKEY_PERCENTSIGN	0x45
#define xKEY_CARET			0x46
#define xKEY_AMPERSAND		0x47
#define xKEY_ANDSIGN		0x47
#define xKEY_STAR			0x48
#define xKEY_ASTERIX		0x48
#define xKEY_LEFTPARENTHESIS 0x49
#define xKEY_OPENINGPARENTHESIS 0x49
#define xKEY_OPENPARENTHESIS 0x49
#define xKEY_TILDE			0x65
#define xKEY_UNDERSCORE		0x66
#define xKEY_PLUS			0x67
#define xKEY_LESSTHAN		0x68
#define xKEY_OPENTAG		0x68
#define xKEY_OPENCHEVRON	0x68
#define xKEY_LEFTCHEVRON	0x68
#define xKEY_GREATERTHAN	0x69
#define xKEY_CLOSETAG   	0x69
#define xKEY_CLOSECHEVRON	0x69
#define xKEY_RIGHTCHEVRON	0x69
#define xKEY_QUESTIONMARK   0x6A
#define xKEY_COLON		    0x6B
#define xKEY_DOUBLEQUOTE	0x6C
#define xKEY_OPENBRACKET	0x6D
#define xKEY_LEFTBRACKET	0x6D
#define xKEY_LEFTBRACE	    0x6D
#define xKEY_CLOSEBRACKET	0x6E
#define xKEY_RIGHTBRACKET	0x6E
#define xKEY_RIGHTBRACE	    0x6E
#define xKEY_BAR    		0x6F
#define xKEY_VERTICALBAR    0x6F
#endif

#define OBJECT_FLAG_IS_DELETED        0x0001 //flag: is deleted?
#define OBJECT_FLAG_IS_ENABLED        0x0002 //flag: enabled?
#define OBJECT_FLAG_IS_ENABLED_STICKY 0x0004 //flag: enable/disable always?
#define OBJECT_FLAG_IS_VISIBLE        0x0008 //flag: show?
#define OBJECT_FLAG_USE_PHYSICS       0x0010 //flag: physics enabled?
#define OBJECT_FLAG_IS_PLATFORM       0x0020 //flag: platform collisions enable?
#define OBJECT_FLAG_USE_SCREEN_COORDS 0x0040 //flag: use screen coordinates instead of level coords?
#define OBJECT_FLAG_PHANTOM_BIT       0x0080 //flag: phantom interaction bit (save bit) set?
#define OBJECT_FLAG_FLIP_X            0x0100 //flag: flip direction is 0 for facing the right, and 1 for facing left
#define OBJECT_FLAG_FLIP_Y            0x0200 //flag: Y-flip (upside down) if set
#define OBJECT_FLAG_GFX_GPU_DOWNLOAD  0x0400
#define OBJECT_FLAG_GFX_SWAP_SRC_DST  0x0800
#define OBJECT_FLAG_GFX_INVERT_RESULT 0x1000
#define OBJECT_FLAG_GFX_INVERT_DST    0x2000
#define OBJECT_FLAG_GFX_INVERT_SRC    0x4000
#define OBJECT_FLAG_GFX_MAPPING_MODE  0x8000
#define OBJECT_FLAG_GFX_INVERT_MASKS 0x10000
#define OBJECT_FLAG_GFX_HAS_PALETTE  0x20000
#define OBJECT_FLAG_GFX_GREYSCALE    0x40000
#define OBJECT_FLAG_GFX_HUE_REPLACE  0x80000
#define OBJECT_FLAG_GFX_COLOR       0x100000
#define OBJECT_FLAG_GFX_OPACITY     0x200000
#define OBJECT_FLAG_GFX_ALPHA       0x400000
#define OBJECT_FLAG_GFX_WRI       0x03800000
#define OBJECT_FLAG_GFX_DST       0x1C000000
#define OBJECT_FLAG_GFX_SRC       0xE0000000
#define OBJECT_FLAG_GFX_DEFAULT   0x04800000
#define OBJECT_FLAG_IS_PAYLOAD   ((NUM)0x100000000LL)

///Basic modes that might forcibly set blending flags
#define BLEND_NOP   0
#define BLEND_NRM   1
#define BLEND_MPK   2
#define BLEND_ALP   3
#define BLEND_ALPo  4
#define BLEND_TXT   5
#define BLEND_TXTo  6
#define BLEND_COL   7
/// Bitwise Standard Modes (Bitwise, Overwrite, Replace, Etc)
#define BLEND_AND   8
#define BLEND_XOR   9
#define BLEND_TRU   10
#define BLEND_XCL   11
#define BLEND_DSS   12
#define BLEND_DSSf  13
#define BLEND_MEA   14
#define BLEND_CPY   15
#define BLEND_REP   16
#define BLEND_MAP   17
/// Basic Mathematics Modes
#define BLEND_ADD_SUB 18
#define BLEND_ADV_SBV 19
#define BLEND_ADW_SBW 20
#define BLEND_ADS 21
#define BLEND_AVG 22
#define BLEND_AVS 23
#define BLEND_XMD 24
#define BLEND_XMP 25
#define BLEND_XMN 26
#define BLEND_AVD 27
#define BLEND_AHD 28
#define BLEND_ABS 29
#define BLEND_ABS2 30
#define BLEND_ABSc 31
#define BLEND_ABSc2 32
#define BLEND_MAX_MIN 33
#define BLEND_AMX 34
#define BLEND_SMX 35
#define BLEND_VMX 36
#define BLEND_CTD 37
#define BLEND_CTM 38
#define BLEND_CTX 39
#define BLEND_GXT 40
#define BLEND_GMR 41
#define BLEND_MULby2 42
#define BLEND_MULby4 43
#define BLEND_DIVby2 44
#define BLEND_DIVby4 45
#define BLEND_SIGNP 46
#define BLEND_SIGNN 47
/// Advanced Mathematics Modes
#define BLEND_MUL 48
#define BLEND_MUL2 49
#define BLEND_MULrl 50
#define BLEND_DIV 51
#define BLEND_MRC 52
#define BLEND_RCP 53
#define BLEND_MOD 54
#define BLEND_fMOD 55
#define BLEND_WHP 56
#define BLEND_fWHP 57
#define BLEND_SQT 58
#define BLEND_RSR 59
#define BLEND_LOG 60
#define BLEND_LOGg 61
#define BLEND_EXP 62
#define BLEND_POW 63
#define BLEND_RPOW 64
/// Advanced Mathematics Modes, Soft Versions
#define BLEND_sDIV 65
#define BLEND_sMRC 66
#define BLEND_sRCP 67
#define BLEND_sMOD 68
#define BLEND_fsMOD 69
#define BLEND_sWHP 70
#define BLEND_fsWHP 71
#define BLEND_sSQT 72
#define BLEND_sRPOW 73
/// Trigonometric Function Modes
#define BLEND_CFT 74
#define BLEND_CFB 75
#define BLEND_CF2 76
#define BLEND_CFQ 77
#define BLEND_CFQ2 78
#define BLEND_CFQ2T 79
#define BLEND_CFQ2B 80
#define BLEND_SIN 81
#define BLEND_COS 82
#define BLEND_ARC 83
#define BLEND_ATAN 84
/// Horizontal Math Modes (RGB Channels Mixing)
#define BLEND_HrzAND 85
#define BLEND_HrzXOR 86
#define BLEND_HrzADD 87
#define BLEND_HrzADV 88
#define BLEND_HrzADW 89
#define BLEND_HrzADS2 90
#define BLEND_HrzADSh 91
#define BLEND_HrzADS1 92
#define BLEND_HrzSUB 93
#define BLEND_HrzMIN 94
#define BLEND_HrzMID 95
#define BLEND_HrzMAX 96
#define BLEND_HrzAMX 97
#define BLEND_HrzSMX 98
#define BLEND_HrzVMX 99
#define BLEND_HrzAVG 100
#define BLEND_HrzMUL 101
#define BLEND_HrzMUL2 102
#define BLEND_HrzMUL4 103
#define BLEND_HrzMUL8 104
#define BLEND_HrzDISTz 105
#define BLEND_HrzDIST 106
/// Horizontal Channel Math Modes (RGB Channels Mixing)
#define BLEND_ChnADF 107
#define BLEND_ChnAVD 108
#define BLEND_ChnDBD 109
/// Advanced Lighting Modes (Heavy Usage)
#define BLEND_OVL   110
#define BLEND_VLT   111
#define BLEND_LLT   112
#define BLEND_PLT   113
#define BLEND_HMX   114
#define BLEND_CLD_CLB 115
#define BLEND_CLL   116
#define BLEND_RFL_GLW 117
#define BLEND_YRX   118
/// Alternate ColorSpace Modes
#define BLEND_GRY   119
#define BLEND_GRYW  120
#define BLEND_POZ   121
#define BLEND_POZW  122
#define BLEND_HUE   123
#define BLEND_HUEr  124
#define BLEND_HST   125
#define BLEND_HVL   126
#define BLEND_SAT   127
#define BLEND_SATc  128
#define BLEND_VAL   129
#define BLEND_VALc  130
/// Professional Blending Modes (Combo Blenders, Etc)
#define BLEND_LFX   131
#define BLEND_DFX   132
#define BLEND_LFXb  133
#define BLEND_DFXb  134
#define BLEND_GST   135
#define BLEND_SLT   136
/// Advanced Modes 2
#define BLEND_DIT   137
#define BLEND_DITp  138
#define BLEND_GIF   139
#define BLEND_GIFf  140
#define BLEND_GIFp  141
#define BLEND_GIFpf 142
/// Parameter Taking Blenders (All Load 128 Bits Regardless of Usage)
#define BLEND_DUT   143
#define BLEND_DUTW  144
#define BLEND_CLZ   145
#define BLEND_CLZW  146
#define BLEND_LUZ   147
#define BLEND_LUZW  148
#define BLEND_ACR   149
#define BLEND_ACRW  150
/// HD Mode Blenders
#define BLEND_HD    151
#define BLEND_HDA   152
#define BLEND_HDADD 153
#define BLEND_HDSUB 154
#define BLEND_HDAVG 155
#define BLEND_HDAVS 156
#define BLEND_HDMIN 157
#define BLEND_HDMAX 158
#define BLEND_HDGXT 159
#define BLEND_HDGMR 160
#define BLEND_HDMUL 161
#define BLEND_HDMLX 162
