#include "deltatypes.h"

ByteCode::ByteCode(){(*this)(0x00,0x00);}//BUGFIX: Required Data Init
ByteCode::ByteCode(NUM a, NUM b){(*this)(a,b);}

ByteCode::operator TXT (){return t(0);}
ByteCode::operator NUM (){return i(0);}
ByteCode::operator FLO (){return f(0);}
ByteCode::operator Vx<NUM> (){return ii(0);}
ByteCode::operator Vx<FLO> (){return ff(0);}
ByteCode::operator Vx<DSXID> (){return dd(0);}
ByteCode::operator Vx<OBJID> (){return oo(0);}
ByteCode::operator DGEID (){return i(0);}
ByteCode::operator FILES (){return i(0);}
ByteCode::operator DLTID (){return i(0);}
ByteCode::operator MUSIC (){return i(0);}
ByteCode::operator SOUND (){return i(0);}
ByteCode::operator OBJID (){return i(0);}
ByteCode::operator LAYER (){return i(0);}
ByteCode::operator FTYPE (){return i(0);}
ByteCode::operator DSXID (){return i(0);}
ByteCode::operator TXTID (){return i(0);}
ByteCode::operator PTHID (){return i(0);}
ByteCode::operator LUCID (){return (TXT)t(0);}

//ByteCode Access Functions
NUM ByteCode::i(NUM index)        {return *((NUM*)       (((U32)this)+Table(index)));}
FLO ByteCode::f(NUM index)        {return *((FLO*)       (((U32)this)+Table(index)));}
const char* ByteCode::t(NUM index){return  ((const char*)(((U32)this)+Table(index)));}
Vx<NUM> ByteCode::ii(NUM index){
    NUM* nums0 = ((NUM*)(((U32)this)+Table(index+0)));
    NUM* nums1 = ((NUM*)(((U32)this)+Table(index+data_[4095])));
    return Vx<NUM>(nums0, nums1); //pointer array initialization **BUGFIXED**
}
Vx<FLO> ByteCode::ff(NUM index){
    FLO* flos0 = ((FLO*)(((U32)this)+Table(index+0)));
    FLO* flos1 = ((FLO*)(((U32)this)+Table(index+data_[4095])));
    return Vx<FLO>(flos0, flos1); //pointer array initialization **BUGFIXED**
}
Vx<DSXID> ByteCode::dd(NUM index){
    NUM* nums0 = ((NUM*)(((U32)this)+Table(index+0)));
    NUM* nums1 = ((NUM*)(((U32)this)+Table(index+1)));
    return Vx<DSXID>(nums0, nums1); //pointer array initialization
}
Vx<OBJID> ByteCode::oo(NUM index){
    NUM* nums0 = ((NUM*)(((U32)this)+Table(index+0)));
    NUM* nums1 = ((NUM*)(((U32)this)+Table(index+1)));
    return Vx<OBJID>(nums0, nums1); //pointer array initialization
}

//ByteCode Return Functions
ByteCode::ByteCode(TXT data)    {(*this)(0xFF,0xFF)(data);}
ByteCode::ByteCode(NUM data)    {(*this)(0xFF,0xFF)(data);}
ByteCode::ByteCode(FLO data)    {(*this)(0xFF,0xFF)(data);}
ByteCode::ByteCode(Vx<NUM> data){(*this)(0xFF,0xFF); for(IND i = 0; i < data.size(); i++){(*this)(data[i]);}}
ByteCode::ByteCode(Vx<FLO> data){(*this)(0xFF,0xFF); for(IND i = 0; i < data.size(); i++){(*this)(data[i]);}}
ByteCode::ByteCode(DGEID data)  {(*this)(0xFF,0xFF)((NUM)data.v);}
ByteCode::ByteCode(FILES data)  {(*this)(0xFF,0xFF)((NUM)data.v);}
ByteCode::ByteCode(DLTID data)  {(*this)(0xFF,0xFF)((NUM)data.v);}
ByteCode::ByteCode(MUSIC data)  {(*this)(0xFF,0xFF)((NUM)data.v);}
ByteCode::ByteCode(SOUND data)  {(*this)(0xFF,0xFF)((NUM)data.v);}
ByteCode::ByteCode(OBJID data)  {(*this)(0xFF,0xFF)((NUM)data.v);}
ByteCode::ByteCode(LAYER data)  {(*this)(0xFF,0xFF)((NUM)data.v);}
ByteCode::ByteCode(FTYPE data)  {(*this)(0xFF,0xFF)((NUM)data.v);}
ByteCode::ByteCode(DSXID data)  {(*this)(0xFF,0xFF)((NUM)data.v);}
ByteCode::ByteCode(TXTID data)  {(*this)(0xFF,0xFF)((NUM)data.v);}
ByteCode::ByteCode(PTHID data)  {(*this)(0xFF,0xFF)((NUM)data.v);}
ByteCode::ByteCode(LUCID data)  {(*this)(0xFF,0xFF)((TXT)data.v);}
ByteCode::ByteCode(Vx<OBJID> da){(*this)(0xFF,0xFF)(da);}

//ByteCode Builder Functions
ByteCode& ByteCode::operator()(){return *this;}
ByteCode& ByteCode::operator()(int data)    {Table(data_[4095]+1) = Set(Table(data_[4095]),(NUM)data); data_[4095]++; return *this;}
ByteCode& ByteCode::operator()(NUM a, NUM b){data_[0]=a; data_[1]=b; Table(0) = (16*sizeof(U32)); data_[4095]=0; return *this;}
ByteCode& ByteCode::operator()(TXT data)    {Table(data_[4095]+1) = Set(Table(data_[4095]),data); data_[4095]++; return *this;}
ByteCode& ByteCode::operator()(NUM data)    {Table(data_[4095]+1) = Set(Table(data_[4095]),data); data_[4095]++; return *this;}
ByteCode& ByteCode::operator()(FLO data)    {Table(data_[4095]+1) = Set(Table(data_[4095]),data); data_[4095]++; return *this;}
ByteCode& ByteCode::operator()(Vx<NUM> data){for(IND i = 0; i < data.size(); i++){(*this)(data[i]);}  return *this;}
ByteCode& ByteCode::operator()(Vx<FLO> data){for(IND i = 0; i < data.size(); i++){(*this)(data[i]);}  return *this;}
ByteCode& ByteCode::operator()(Vx<OBJID> da){Table(data_[4095]+1) = Set(Table(data_[4095]),da);   data_[4095]++; return *this;}
ByteCode& ByteCode::operator()(DGEID data)  {Table(data_[4095]+1) = Set(Table(data_[4095]),(NUM)data.v); data_[4095]++; return *this;}
ByteCode& ByteCode::operator()(FILES data)  {Table(data_[4095]+1) = Set(Table(data_[4095]),(NUM)data.v); data_[4095]++; return *this;}
ByteCode& ByteCode::operator()(DLTID data)  {Table(data_[4095]+1) = Set(Table(data_[4095]),(NUM)data.v); data_[4095]++; return *this;}
ByteCode& ByteCode::operator()(MUSIC data)  {Table(data_[4095]+1) = Set(Table(data_[4095]),(NUM)data.v); data_[4095]++; return *this;}
ByteCode& ByteCode::operator()(SOUND data)  {Table(data_[4095]+1) = Set(Table(data_[4095]),(NUM)data.v); data_[4095]++; return *this;}
ByteCode& ByteCode::operator()(OBJID data)  {Table(data_[4095]+1) = Set(Table(data_[4095]),(NUM)data.v); data_[4095]++; return *this;}
ByteCode& ByteCode::operator()(LAYER data)  {Table(data_[4095]+1) = Set(Table(data_[4095]),(NUM)data.v); data_[4095]++; return *this;}
ByteCode& ByteCode::operator()(FTYPE data)  {Table(data_[4095]+1) = Set(Table(data_[4095]),(NUM)data.v); data_[4095]++; return *this;}
ByteCode& ByteCode::operator()(DSXID data)  {Table(data_[4095]+1) = Set(Table(data_[4095]),(NUM)data.v); data_[4095]++; return *this;}
ByteCode& ByteCode::operator()(TXTID data)  {Table(data_[4095]+1) = Set(Table(data_[4095]),(NUM)data.v); data_[4095]++; return *this;}
ByteCode& ByteCode::operator()(PTHID data)  {Table(data_[4095]+1) = Set(Table(data_[4095]),(NUM)data.v); data_[4095]++; return *this;}
ByteCode& ByteCode::operator()(LUCID data)  {Table(data_[4095]+1) = Set(Table(data_[4095]),data.v); data_[4095]++; return *this;}

ByteCode& ByteCode::operator()(ByteCode& r){
    //UNUSED IN OBJECT DLOs, RETURN UNMODIFIED STRUCTURE
    return *this;
}

U32& ByteCode::Table(NUM index){return *((U32*)&data_[4+(index << 2)]);}

U32 ByteCode::Set(U32 where, TXT text){
    U32 i, j;
    for(i = where, j = 0; ((i < 4094) && (j < text.size())); i++, j++){
        data_[i] = text[j];
    }
    data_[i] = '\0';
    return (i + 1);
}
U32 ByteCode::Set(U32 where, NUM var){
    *((NUM*)(&data_[where])) = var;
    return (where + 8);
}
U32 ByteCode::Set(U32 where, FLO var){
    *((FLO*)(&data_[where])) = var;
    return (where + 8);
}
U32 ByteCode::Set(U32 where, Vx<NUM> var){
    for(U32 i = 0; i < var.size(); i++){
        *((NUM*)(&data_[i*8+where])) = var[i];
    }
    return (where+(var.size()*8));
}
U32 ByteCode::Set(U32 where, Vx<FLO> var){
    for(U32 i = 0; i < var.size(); i++){
        *((FLO*)(&data_[i*8+where])) = var[i];
    }
    return (where+(var.size()*8));
}
U32 ByteCode::Set(U32 where, Vx<OBJID> var){
    for(U32 i = 0; i < var.size(); i++){
        *((NUM*)(&data_[i*8+where])) = var[i];
    }
    return (where+(var.size()*8));
}
NUM ByteCode::GetA(){return data_[0];}
NUM ByteCode::GetB(){return data_[1];}
